<?php
/*
Набор функция для разруливателя
Автор: Denvas
http://bmatrix.net/
*/
    //==================================================//
    function NameUID($uid, $namefile){    
        return "users/".(1+(int)($uid/1000))."/".$uid."/".$namefile;
    };
    //==================================================//
    /*
    Генерация нового ID
    */
    function NewID($name){
        global $path_data;
        $namefile=$path_data."/".$name."id.dat";
        $fl=fopen($namefile.".lock","wb");
        flock($fl,LOCK_EX);
        $id=(int)@file_get_contents($namefile);
        if(empty($id))$id=100;
        $id++;
        $fd=fopen($namefile,"wb");
        fwrite($fd,$id);
        fclose($fd);
        fclose($fl);
        return $id;
    };
    //==================================================//
    /*
    Получение инфомрации о пользователе по id или e-mail
    */
    function GetUser($search,$poss){
        global $path_data;
        $data=@file($path_data."/password.dat");
        $ndata=count($data);
        for($i=0;$i<$ndata;$i++){
            $elem=explode("|",trim($data[$i]));
            if(empty($elem[$poss]))continue;
            if(strcmp($elem[$poss],$search)!=0)continue;
            return array("pos"=>$i,"id_user"=>$elem[0],"wappcid"=>$elem[1],"pwd"=>$elem[2],"regtime"=>$elem[3]);
        };//for
        return array();
    };
    //==================================================//
    /*
    Верх страницы
    */
    function data_header(){
        global $rescount, $user_agent, $wapver, $template, $codereplace, $uid, $robots;
        setcookie("tu",time(),time()+30*24*60*60,"/");
        $template=InitDesign("standart",$wapver);
		$codereplace[TMPL."cssfile".TMPL]=NameUID($uid,"style.css");
        //убирать id для поисковиков
        if((!empty($robots))&&(isset($_GET["uid"]))){
            Relocation(QueryParam(array("uid")),"",-1);
        };
    };
    //==================================================//
    /*
    Низ страницы
    */
    function data_bottom($name="main",$align="left"){
        global $code, $codemenu, $title, $template, $endcode, $catinfo, $keyword;
        $code=strtr($template[$name],array(TMPL."headmeta".TMPL=>empty($catinfo["headmeta"])?"":$catinfo["headmeta"],TMPL."align".TMPL=>$align,TMPL."code".TMPL=>$code,TMPL."menu".TMPL=>$codemenu,TMPL."title".TMPL=>$title,TMPL."codeend".TMPL=>$endcode,TMPL."banner".TMPL=>"",TMPL."keywords".TMPL=>$keyword));
    };
    //==================================================//
    function MainMenu($name="mainmenu"){
        global $template, $path_text, $datauid, $id_client, $nrowpage;
        $temprows=$nrowpage;
        $nrowpage=1000;
        //меню
        $res=ViewText($name,array(),false,"<br/>","!menu");
        $nrowpage=$temprows;
        if($res){
            list($code,$title,$keyword)=$res;
            if((!empty($datauid["title"]))&&(!empty($id_client))&&($id_client!=$datauid["login"])){
                $code.="<a href='".QueryParam(array(),1,"../".$datauid["login"]."/")."'>".$datauid["title"]."</a><br/>";
            };
            $codemenu=strtr($template["menu"],array(TMPL."title".TMPL=>$title,TMPL."code".TMPL=>$code));
            return $codemenu;
        };
        return "";
    };
    //==================================================//
    /*
    получение всей информации о пользоватале
    */
    function GetUserInfo(){
        global $user_agent;

        //регистрация сессии, если еще не зарегистрирована
        if((isset($_GET["sid"]))&&(empty($_SESSION))){
            session_name("sid");
            session_start();
        };
        if((empty($_SESSION))||(strcmp($_SESSION["user_agent"],$user_agent)!=0)||($_SESSION["timeupdate"]<time()-60*60)||(empty($_SESSION["__clientwapfinder"]))){
            $_SESSION=array();
        }
        else{
            $_SESSION["timeupdate"]=time();
        };
        return $_SESSION;
    };
    //==================================================//
    /*
    Запись файла с поддержкой выхода в случае демоверсии
    */
    function SaveFile($filename,$content,$flag="wb"){
        $fd=fopen($filename,$flag);
        if(!$fd)return false;
        flock($fd,LOCK_EX);
        fwrite($fd,$content);fclose($fd);
        return true;
    };
    //==================================================//
    /*
    Запись файла с поддержкой выхода в случае демоверсии
    */
    function SaveProfile($profile){
		global $nameuid;
		$str="<?php\n\$profile=".var_export($profile,true)."\n?>";
		SaveFile($nameuid,$str,"wb");
        return true;
    };
	
?>